package org.jboss.gravel.action;

import org.jboss.gravel.action.handler.AttributeHandler;
import org.jboss.gravel.action.handler.CheckRoleHandler;
import org.jboss.gravel.action.handler.LogOutHandler;
import org.jboss.gravel.action.handler.MessageHandler;
import org.jboss.gravel.action.handler.ParameterHandler;
import org.jboss.gravel.action.handler.ResponseActionsHandler;
import org.jboss.gravel.action.handler.KeepAliveHandler;
import org.jboss.gravel.action.ui.UIResponseActions;

import com.sun.facelets.tag.AbstractTagLibrary;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;
import javax.faces.render.RenderKit;

/**
 *
 */
public final class ActionLibrary extends AbstractTagLibrary {
    public ActionLibrary() {
        super("http://gravel.jboss.org/jsf/1.0/action");

        final FacesContext facesContext = FacesContext.getCurrentInstance();
        final RenderKit renderKit = facesContext.getRenderKit();
        final Application application = facesContext.getApplication();

        // Add all components
        application.addComponent(UIResponseActions.COMPONENT_TYPE, UIResponseActions.class.getName());
        addComponent("responseActions", UIResponseActions.COMPONENT_TYPE, null, ResponseActionsHandler.class);

        addTagHandler("parameter", ParameterHandler.class);
        addTagHandler("message", MessageHandler.class);
        addTagHandler("attribute", AttributeHandler.class);
        addTagHandler("logOut", LogOutHandler.class);
        addTagHandler("checkRole", CheckRoleHandler.class);
        addTagHandler("keepAlive", KeepAliveHandler.class);
    }
}
