package org.jboss.gravel.action.handler;

import java.io.IOException;

import com.sun.facelets.tag.TagHandler;
import com.sun.facelets.tag.TagException;
import com.sun.facelets.tag.TagConfig;
import com.sun.facelets.tag.jsf.ComponentSupport;
import com.sun.facelets.FaceletContext;

import javax.faces.component.UIComponent;
import javax.faces.component.ActionSource;
import javax.faces.FacesException;
import javax.el.ELException;

import org.jboss.gravel.action.action.LogOutActionListener;
import org.jboss.gravel.common.annotation.TldTag;

/**
 *
 */
@TldTag (
    name = "logOut",
    description = "Add an action handler to the enclosing component that invalidates the current session."
)
public final class LogOutHandler extends TagHandler {
    public LogOutHandler(final TagConfig config) {
        super(config);
    }

    public void apply(FaceletContext ctx, UIComponent parent) throws IOException, FacesException, ELException {
        try {
            if (! (parent instanceof ActionSource)) {
                throw new TagException(tag, "Parent component is not an ActionSource");
            }
            if (ComponentSupport.isNew(parent)) {
                ((ActionSource)parent).addActionListener(new LogOutActionListener());
            }
        } catch (TagException tex) {
            throw tex;
        } catch (RuntimeException rex) {
            TagException tex = new TagException(tag, "An exception of type " + rex.getClass().getName() + " occurred: " + rex.getMessage());
            tex.setStackTrace(rex.getStackTrace());
            throw tex;
        }
    }
}
