/*
    Gravel - Component library for JSF
    Copyright (C) 2007  David M. Lloyd

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.jboss.gravel.compat;

import org.jboss.gravel.common.ui.UICollectionEntry;
import org.jboss.gravel.compat.handler.DataTableColumnHandler;
import org.jboss.gravel.compat.handler.DataTableHandler;
import org.jboss.gravel.compat.renderer.DataTableRenderer;
import org.jboss.gravel.compat.ui.UIDataTable;
import org.jboss.gravel.compat.ui.UIDataTableColumn;

import com.sun.facelets.tag.AbstractTagLibrary;

import javax.faces.application.Application;
import javax.faces.context.FacesContext;
import javax.faces.render.RenderKit;

/**
 *
 */
public final class CompatLibrary extends AbstractTagLibrary {
    public CompatLibrary() {
        super("http://gravel.jboss.org/jsf/1.0/compat");

        final FacesContext facesContext = FacesContext.getCurrentInstance();
        final RenderKit renderKit = facesContext.getRenderKit();
        final Application application = facesContext.getApplication();

        // Add the special collection component - it has no renderer because it is rendered by the enclosing component
        // TODO - move to separate init module?
        application.addComponent(UICollectionEntry.COMPONENT_TYPE, UICollectionEntry.class.getName());

        // Compatibility dataTable
        application.addComponent(UIDataTable.COMPONENT_TYPE, UIDataTable.class.getName());
        application.addComponent(UIDataTableColumn.COMPONENT_TYPE, UIDataTableColumn.class.getName());
        renderKit.addRenderer(UIDataTable.COMPONENT_FAMILY, UIDataTable.RENDERER_TYPE, new DataTableRenderer());
        addComponent("dataTable", UIDataTable.COMPONENT_TYPE, UIDataTable.RENDERER_TYPE, DataTableHandler.class);
        addComponent("column", UIDataTableColumn.COMPONENT_TYPE, null, DataTableColumnHandler.class);
    }
}
