package org.jboss.gravel.data.renderer;

import org.jboss.gravel.common.renderer.RendererBase;
import org.jboss.gravel.common.renderer.Element;
import org.jboss.gravel.data.ui.UIInputHidden;

import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.convert.Converter;
import javax.faces.validator.Validator;

import java.io.IOException;
import java.util.Map;

import java.util.logging.Logger;
import java.util.logging.Level;

/**
 *
 */
public final class InputHiddenRenderer extends RendererBase {

    public InputHiddenRenderer() {
    }

    public void decode(FacesContext context, UIComponent component) {
        log.fine("XXXX 1");
        if (! component.isRendered()) {
            return;
        }
        log.fine("XXXX 2");
        UIInputHidden input = (UIInputHidden) component;
        final String id = input.getClientId(context);
        final Map<String,String> parameterMap = context.getExternalContext().getRequestParameterMap();
        final String inputValue = parameterMap.get(id);
        if (inputValue != null) {
            log.fine("XXXX 3");
            final Object value;
            final Converter converter = input.getConverter();
            if (converter == null) {
                value = inputValue;
            } else {
                value = converter.getAsObject(context, input, inputValue);
            }
            log.fine("XXXX 4");
            final Validator[] validators = input.getValidators();
            for (Validator validator : validators) {
                // TODO - catch and format validation exceptions
                validator.validate(context, input, value);
            }
            log.fine("XXXX 5");
            input.updateTarget(context, value);
        } else {
            if (log.isLoggable(Level.FINE)) {
                log.fine("Client ID '" + id + "' not found in request map, skipping");
            }
        }
    }

    public void encodeBegin(FacesContext context, UIComponent component) throws IOException {
        // nothing
    }

    public void encodeEnd(FacesContext context, UIComponent component) throws IOException {
        if (! component.isRendered()) {
            return;
        }
        UIInputHidden input = (UIInputHidden) component;
        final Element<UIComponent> element = writeElement(context, "input", component);
        element.writeAttribute("type", "hidden");
        element.writeId("id", true);
        element.writeId("name", false);
        final Object value = input.getValue();
        // Convert value for output
        final String outputValue;
        final Converter converter = input.getConverter();
        if (converter == null) {
            outputValue = value == null ? "" : value.toString();
        } else {
            outputValue = converter.getAsString(context, input, value);
        }
        element.writeAttribute("value", outputValue);
        element.close();
    }

    public boolean getRendersChildren() {
        return false;
    }

    private static final Logger log = Logger.getLogger("org.jboss.gravel.data.renderer.FileInputRenderer");
}
